
class Planet:
    def __init__(self, name, width, height, tiles):
        """
        Initialise the planet object
        """
        self.box_size = 5
        self.name = name
        self.width = width
        self.height = height
        self.tiles = tiles
        self.shades = [['#' if tile.is_shaded() else ' ' for tile in row] for row in self.tiles]
        
    def shade_scan(self, rover):
        x0, y0 = rover.x, rover.y
        print('')
        for x in range(x0 - self.box_size//2, x0 + self.box_size//2 + 1):
            row = []
            for y in range(y0 - self.box_size//2, y0 + self.box_size//2 + 1):
                x = x % self.height
                y = y % self.width
                if (x, y) not in rover.visited:
                    rover.visited.append((x, y))
                if (x, y) == (x0, y0):
                    row.append('H')
                else:
                    row.append(self.shades[x][y])
            print("|" + "|".join(row) + "|")
        print('')
        
    def elevation_scan(self, rover):
        x0, y0 = rover.x, rover.y
        print('')
        for x in range(x0 - self.box_size//2, x0 + self.box_size//2 + 1):
            row = []
            for y in range(y0 - self.box_size//2, y0 + self.box_size//2 + 1):
                x = x % self.height
                y = y % self.width
                if (x, y) not in rover.visited:
                    rover.visited.append((x, y))
                if (x, y) == (x0, y0):
                    row.append('H')
                else:
                    diff = self.tiles[x][y].elevation() - self.tiles[x0][y0].elevation()
                    if self.tiles[x0][y0].is_sloped() and diff in [0, -1]:
                        row.append(' ')
                    elif diff > 0:
                        if self.tiles[x][y].is_sloped() and diff == 1:
                            row.append('/')
                        else:
                            row.append('+')
                    elif diff < 0:
                        row.append('-')
                    elif diff == 0 and self.tiles[x][y].is_sloped():
                        row.append('\\')
                    else:
                        row.append(' ')
            print("|" + "|".join(row) + "|")
        print('')
    
    
    
    
    
